 function [FRN_ref_inv,FRN_ref_LABEL,FRN_ld,FRN_samp_inv,FRN_samp_LABEL,...
                                 comp_depth,scenario] = MODERN_input(site_ID)
switch site_ID
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIRST CASE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STUDY AREA
    case 'StudyArea1'  % Name of the case : remember to use the same as in MODERN_run
        
% SPECIFICATIONS:
%A. REFERENCE SITES:
FRN_ref_inv = { [10 30 20 15 8]};
                % FRN inventory at each layer. You can as many as you want, and also as may ref sites as you need.
%each ref site is included in the "[]" and separeted by ";"
            
FRN_ref_LABEL = {'Reference Site 1'};
                % Label of the ref site. It will be printed in the plot. Number of labels need to be the same as number of FRN_ref_inv
                % each label is included in "''" and separeted by ";"

FRN_ld = 3; % depth increment considered in the ref site


%B. SAMPLING SITES: 
FRN_samp_inv = [40 65 94 ]; % total inv of the sampling sites. Each tot inv is separated by space.
FRN_samp_LABEL = {'site1';'site2';'site3'}; % label of samp site. It will be printed in the plot. Number of labels need to be the same as number of FRN_samp_inv
comp_depth = 15; % depth of the tot inventory of sampling sites considered for the comparison with the reference site.

%C. SCENARIOS:
% each line is considered as a scenario, so first line is scenario 1 and so on.
% It works only for deposition. For layer below the measured one it assumes
% exponential decline.
% for each layer you can specify the value to be simulated. 
% write the number of the layer and then put the double point ":" like this-->  1:
% different layers prescriptions are separated with ';'.
%   here is an example:
%   ['1: 1 2 3; 2: v15; 3: 20%*4']
% where  
%   - layer number 1 gets average of layers 1,2,3 
%   - layer number 2 gets fixed value 15 (fixed value starts with 'v')
%   - layer number 3 gets value 20%*layer 4  (we use here '20%*', after * one can put 1 2 3 in order to have 20% of average of layers 1 2 3)

scenario = {'1: 1 2; 2: 1 2 3'; %1
'1:1; 2: v15' %2
};

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SECOND CASE - Example of a scenario where the reference site is adapted
% in order to simulate the mixing of FRN due to ploughing activities
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STUDY AREA
    case 'StudyArea2'
        
% SPECIFICATIONS:
%A. REFERENCE SITES:
FRN_ref_inv = {[1500 1350 1000 990 870 600 300 250 200 100];
                [1142 1142 1142 1142 1142 600 300 250 200 100]};
            
FRN_ref_LABEL = {'Reference Site 1 ';
                 ' Reference Site 1 (ploughed/mixed up to 15 cm'};

FRN_ld = 3;

%B. SAMPLING SITES: 
FRN_samp_inv = [6000 6200 8000]; 
FRN_samp_LABEL = {'site1 (uncultivated)';'site2 (ploughed)';'site3 (ploughed)'};
comp_depth = 30;

%C. SCENARIOS:
scenario = {'1: 1';
    '1: 120%*1'
};

end    
end
           
           
