function intersec_ranges = computeStepFunctionInverseSet(y_val,nodes,eps)
num_nodes = size(nodes,1);
nodes_inds = (1:num_nodes)';
%SIGNumS: 1/0/-1, if node lies above/on/under the y_val-line
signs = zeros(num_nodes,1);
signs(nodes(:,2)>y_val+eps)=1;
signs(nodes(:,2)<y_val-eps)=-1;
%intersec_ranges:
intersec_ranges = zeros(num_nodes,2); %more rows as needed
%TRANSversal_SEGMentS:
trans_segms = zeros(num_nodes,2); %more rows as needed
ir_ind = 1; %"IntersectionRanges_INDex"
ts_ind = 1; %"TransversalSegments_INDex"
if ~isempty(signs) %signs is empty is very unlikely
if signs(1)==0
    %save left boundary of intersection range:
    intersec_ranges(ir_ind,1) = nodes(1,1);
    %position of the next non-zero element (can be empty):
    next_pos = find(~(signs==0),1);
    if isempty(next_pos) %all elements are zero in signs
        %choose next_pos, s.t. the last x of nodes can be assigned as right
        %boundary of intersection range and signs can be deleted after this
        %part
        next_pos = num_nodes+1;
    end
    %save right boundary of intersection range:
    intersec_ranges(ir_ind,2) = nodes(next_pos-1,1);        
    %increase ir_ind:
    ir_ind = ir_ind + 1;
    %delete used elements of signs and node_inds:
    signs(1:next_pos-1) = [];
    nodes_inds(1:next_pos-1) = [];
end
end
while ~isempty(signs) %signs not empty
    %the 1st curr_sign is non-zero (due to first part)
    curr_pos = 1;
    curr_sign = signs(curr_pos);
    %position of the next not "sign" element:
    next_pos = find(~(signs==curr_sign),1);
    if ~isempty(next_pos)
        next_sign = signs(next_pos);
        if next_sign == 0
            %save left boundary of intersection range:
            intersec_ranges(ir_ind,1) = nodes(nodes_inds(next_pos),1);
            signs(1:next_pos-1) = [];
            nodes_inds(1:next_pos-1) = [];
            next_pos = find(~(signs==0),1);
            if isempty(next_pos) %all elements are zero in signs
                %choose next_pos, s.t. the last x of nodes can be assigned 
                %as right boundary of intersection range and signs can be 
                %deleted after this part
                next_pos = length(nodes_inds)+1;
            end
                %save right boundary of intersection range:
                intersec_ranges(ir_ind,2) = nodes(nodes_inds(next_pos-1),1);
            %increase ir_ind:
            ir_ind = ir_ind+1;
        else %next_sign = - curr_sign --> conversion: there is an intersec.
             %point between nodes(next_pos-1)& nodes(next_pos)
             %accumulate data for this case:
             trans_segms(ts_ind,:) = [nodes_inds(next_pos-1) 
                                                     nodes_inds(next_pos)];
             %increase ts_ind:
             ts_ind = ts_ind + 1;
        end
    else %next_pos is empty; we are done!
         %choose next_pos, s.t. signs will be deleted in this step
        next_pos = length(nodes_inds)+1;
    end
           %delete used elements of signs and node_inds:
           signs(1:next_pos-1) = [];
           nodes_inds(1:next_pos-1) = [];
end
%delete remained rows of trans_segms:
trans_segms(ts_ind:end,:) = [];
ts_num = size(trans_segms,1); %TransversalSegments_NUMber
%allocate ts_num rows at the end of intersec_ranges and delete left rows:
intersec_ranges(ir_ind+ts_num:end,:) = [];
%handle all the cases next_sign=-curr_sign together (based on trans_segms):
if ~isempty(trans_segms)
    P1 = nodes(trans_segms(:,1),:); P2 = nodes(trans_segms(:,2),:);
    %find intersection points:
    X = findIntersectionX(P1,P2,y_val);
    %save intersection points both as left and right boundaries of
    %intersection range:
    intersec_ranges(ir_ind:end,[1 2]) = [X X];
end
%sort intersec_ranges:
intersec_ranges = sortrows(intersec_ranges,1);    
end

function X = findIntersectionX(P0,P1,y)
num_lines = size (P0,1);
if num_lines==0 %case P0,P1 are empty
    X = [];
else
    X0 = P0(:,1); Y0 = P0(:,2);
    X1 = P1(:,1); Y1 = P1(:,2);
    Y = y*ones(num_lines,1);
    T = (Y-Y0)./(Y1-Y0);
    X = (1-T).*X0+T.*X1;
end
end