%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%compute value of a piecewise linear function G at x_val
%input:
%x_val   x-value of G
%G,x     data of G
%eps     accuracy
%output:
%y_val   G(x_val)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function y_val = computeValueOfG (x_val,G,x,eps)
diff = x-x_val; x_num = length(x);
x_ind = abs(diff)<10e-6;
if sum(x_ind)>0 %x_val = x_i
    y_val = G(round(mean(find(x_ind)))); % for the case of many "quite" 
    %same entries: we take average index for xfuer "
else % x_val ~= x_i
    marker = sum(diff<eps); 
    if marker == 0 
        disp('x_val is negative!');
        y_val = [];
    else if marker == x_num % x_val ist groesser als alle Eintraege von x
            disp('x bigger than x_max!');
            y_val = [];
        else %es gibt ein Intervall I=[x_(i-1),x_i], mit x in I
            x_ind = [marker marker+1];
            xs = x(x_ind); ys = G(x_ind);
            %x_val ist der x-Wert des Punktes (x_val,y_val) auf dem
            %Geradenstueck zw. den Punkten (xs(1),ys(1)) und (xs(2),ys(2)
            y_val = ys(1)+(x_val-xs(1))*(ys(2)-ys(1))/(xs(2)-xs(1));
        end
    end
end
end
