%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%create and plot extended reference profile
%input:
%x,c,d,h,
%curr_scenario,
%c_n_plot:         see parent function (createS)
%output:
%x_ext,c_ext:      data of the extended reference profile
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [x_ext,c_ext] = createExtendedReferenceFRNInvData_mod(x,c,d,h,...
                                                    curr_scenario,c_n_plot)
                                      
x_min = x(1); x_max = x(end);   
%artifical data extension:
c_lext = createScenarioReferenceFRNInvData(curr_scenario,c);
spec_lays_num = length(c_lext);
%left extension of x:
if spec_lays_num>0
    x_lext = x_min-spec_lays_num*h:h:x_min-h;
else
    x_lext = [];
end
%right extension of x:
x_rext = x_max+h:h:h*ceil((x_max+d)/h);
%extended x
x_ext = [x_lext x x_rext];

                                           %assumption for "gain" layers:
                                           %according to curr_scenario
%right extension of c:
c_rext = c(end)*exp(-(1:length(x_rext))); %assumption for "loss" layers:
                                          %exponential decrease with depth

%extended c:
c_ext = [c_lext c c_rext];

%"(PLOT)begin" plot extended step function:
if c_n_plot>0
figure(c_n_plot); clf;
subplot(1,2,2);
set(gca,'XTick',x_ext(1):3:x_ext(end),'TickDir','out');
grid on
% set(gca,'gridlinestyle','--')
%axis equal
hold on
%step function - left "fake" part:
x_left = [x_lext 0];
if isempty(c_lext)
    c_left = [];
else
    c_left = [c_lext c_lext(end)];
    stairs(x_left,h*c_left,'Color','b','LineWidth',1.5);
    %vertical lines:
    X = repmat(x_left,2,1);
    Y = [h*c_left;zeros(1,length(c_left))];
    line(X,Y,'Color','b','LineWidth',1.5);
    
end
%step function - middle "true" part:
x_middle = x;
c_middle = [c c(end)];
stairs(x_middle,h*c_middle,'Color','r','LineWidth',1.5);
%vertical lines:
X = repmat(x_middle,2,1);
Y = [h*c_middle;zeros(1,length(c_middle))];
line(X,Y,'Color','r','LineWidth',1.5);
%step function - right "fake" part:
x_right = [x(end) x_rext];
c_right = [c_rext c_rext(end)];
stairs(x_right,h*c_right,'Color','b','LineWidth',1.5);
%vertical lines:
X = repmat(x_rext,2,1);
Y = [h*c_rext;zeros(1,length(c_rext))];
line(X,Y,'Color','b','LineWidth',1.5);
hold off
end
%"(PLOT)end"
end