%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%create the primitive function G through (x_min,0) of a step function g(x)
%input:
%x,c :  inventories of reference profile, describe step function g(x) where
%       c(i) is value on segment [x(i),x(i+1)]
%output:
%G:     values of primitive function G(x), corresponds to x, is a piecewise
%       linear function
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function G = createG(c,x)
c_num = length(c);
if length(x)==c_num+1 %sizes of c and x are compatible
    G = zeros(c_num+1,1); %column vector for values of G
    if c_num>0 %c is not empty
        Z = c.*(x(2:end)-x(1:end-1));
        H = tril(repmat(Z,c_num,1)); h = sum(H,2);
        G(2:end) = h;
    else %n==0 (c is empty)
        G = []; 
    end
else
    error('function G can not be generated: sizes of c and x dismatch. correct matching: length(c)= length(x)-1))')
end
end
