%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%create upper artificial layers data of the reference profile
%input:
%curr_scenario: scenario data
%c:             see parent function (createS)
%output:
%c_lext: FRN values for the upper artificial layers according to scenario
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function c_lext = createScenarioReferenceFRNInvData(curr_scenario,c)
%extract data from curr_scenario:
scs_array = strsplit(curr_scenario,';'); %"SpecLaysStr_ARRAY"
rules_num = length(scs_array);
%c_lext: left extension
c_lext = zeros(1,rules_num);
for i = 1:rules_num
     plus = 0;
     curr_scs_array = strsplit(char(scs_array(i)),':');
     indicator = char(curr_scs_array(1));
     if ~isempty(strfind(indicator,'exp')) %current rule contains 'exp'
     if ~isempty(strfind(indicator,'+')) %case 'exp+'
         h = strsplit(indicator,'exp+');
         plus = 1;
     else %case 'exp'
         h = strsplit(indicator,'exp');
         plus = 0;
     end
     ind = str2num(char(h(1)));
     n = str2num(char(h(end)));
     start_value = readValue(char(curr_scs_array(2)),c);
     if plus
     c_lext(ind:ind+n-1) = start_value*exp(-(1:n));
     else
     c_lext(ind:ind+n-1) = start_value*exp(-(0:n-1));
     end
     elseif ~isempty(str2num(char(indicator)))%standard case w/o 'exp'
     ind = str2num(char(indicator));
     c_lext(ind) = readValue(char(curr_scs_array(2)),c); 
     end 
end
c_lext = flip(c_lext);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%computes the value of the layer encoded in scenario:
%input: 
%str:   part of scenario string corresponding to value of layer 
%c:     see parent function (createS)
%output:
%value: resulted value
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function value=readValue(str,c)
if  isempty(strfind(str,'v')) %current rule does not contain 'v'
    data_array = strsplit(str,'%');
    if length(data_array)==2 %current rule contains '%'
    p = str2num(char(data_array(1)));
    s = char(data_array(2));
    %modify data_array(2): delete '*'-caracter
    s(s=='*') = [];
    curr_layers_data = str2num(s);
    else
    p = 100;
    curr_layers_data = str2num(char(data_array(end)));
    end
    value = p/100*mean(c(curr_layers_data));
else %current rule contains 'v'
    h = strsplit(str,'v');
    value = str2num(char(h));
end
end
